// generated from rosidl_generator_c/resource/idl__description.c.em
// with input from marker_msgs:msg/Fiducial.idl
// generated code does not contain a copyright notice

#include "marker_msgs/msg/detail/fiducial__functions.h"

ROSIDL_GENERATOR_C_PUBLIC_marker_msgs
const rosidl_type_hash_t *
marker_msgs__msg__Fiducial__get_type_hash(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_type_hash_t hash = {1, {
      0xa0, 0xbb, 0xf1, 0x1d, 0x48, 0xcd, 0x99, 0x91,
      0x74, 0x8c, 0xa9, 0xbb, 0x94, 0x40, 0xce, 0x8e,
      0x82, 0x7b, 0xee, 0xe0, 0x2f, 0x75, 0xa9, 0x60,
      0xe0, 0x8f, 0xf8, 0x27, 0x98, 0x1f, 0x14, 0xac,
    }};
  return &hash;
}

#include <assert.h>
#include <string.h>

// Include directives for referenced types
#include "geometry_msgs/msg/detail/point__functions.h"

// Hashes for external referenced types
#ifndef NDEBUG
static const rosidl_type_hash_t geometry_msgs__msg__Point__EXPECTED_HASH = {1, {
    0x69, 0x63, 0x08, 0x48, 0x42, 0xa9, 0xb0, 0x44,
    0x94, 0xd6, 0xb2, 0x94, 0x1d, 0x11, 0x44, 0x47,
    0x08, 0xd8, 0x92, 0xda, 0x2f, 0x4b, 0x09, 0x84,
    0x3b, 0x9c, 0x43, 0xf4, 0x2a, 0x7f, 0x68, 0x81,
  }};
#endif

static char marker_msgs__msg__Fiducial__TYPE_NAME[] = "marker_msgs/msg/Fiducial";
static char geometry_msgs__msg__Point__TYPE_NAME[] = "geometry_msgs/msg/Point";

// Define type names, field names, and default values
static char marker_msgs__msg__Fiducial__FIELD_NAME__ids[] = "ids";
static char marker_msgs__msg__Fiducial__FIELD_NAME__ids_confidence[] = "ids_confidence";
static char marker_msgs__msg__Fiducial__FIELD_NAME__object_points[] = "object_points";
static char marker_msgs__msg__Fiducial__FIELD_NAME__image_points[] = "image_points";

static rosidl_runtime_c__type_description__Field marker_msgs__msg__Fiducial__FIELDS[] = {
  {
    {marker_msgs__msg__Fiducial__FIELD_NAME__ids, 3, 3},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_INT32_UNBOUNDED_SEQUENCE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {marker_msgs__msg__Fiducial__FIELD_NAME__ids_confidence, 14, 14},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_DOUBLE_UNBOUNDED_SEQUENCE,
      0,
      0,
      {NULL, 0, 0},
    },
    {NULL, 0, 0},
  },
  {
    {marker_msgs__msg__Fiducial__FIELD_NAME__object_points, 13, 13},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_NESTED_TYPE_UNBOUNDED_SEQUENCE,
      0,
      0,
      {geometry_msgs__msg__Point__TYPE_NAME, 23, 23},
    },
    {NULL, 0, 0},
  },
  {
    {marker_msgs__msg__Fiducial__FIELD_NAME__image_points, 12, 12},
    {
      rosidl_runtime_c__type_description__FieldType__FIELD_TYPE_NESTED_TYPE_UNBOUNDED_SEQUENCE,
      0,
      0,
      {geometry_msgs__msg__Point__TYPE_NAME, 23, 23},
    },
    {NULL, 0, 0},
  },
};

static rosidl_runtime_c__type_description__IndividualTypeDescription marker_msgs__msg__Fiducial__REFERENCED_TYPE_DESCRIPTIONS[] = {
  {
    {geometry_msgs__msg__Point__TYPE_NAME, 23, 23},
    {NULL, 0, 0},
  },
};

const rosidl_runtime_c__type_description__TypeDescription *
marker_msgs__msg__Fiducial__get_type_description(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static bool constructed = false;
  static const rosidl_runtime_c__type_description__TypeDescription description = {
    {
      {marker_msgs__msg__Fiducial__TYPE_NAME, 24, 24},
      {marker_msgs__msg__Fiducial__FIELDS, 4, 4},
    },
    {marker_msgs__msg__Fiducial__REFERENCED_TYPE_DESCRIPTIONS, 1, 1},
  };
  if (!constructed) {
    assert(0 == memcmp(&geometry_msgs__msg__Point__EXPECTED_HASH, geometry_msgs__msg__Point__get_type_hash(NULL), sizeof(rosidl_type_hash_t)));
    description.referenced_type_descriptions.data[0].fields = geometry_msgs__msg__Point__get_type_description(NULL)->type_description.fields;
    constructed = true;
  }
  return &description;
}

static char toplevel_type_raw_source[] =
  "# This expresses a known detected fiducial in image space\n"
  "int32[] ids                         # possible ids of the detected fiducial (empty if no id could be identified)\n"
  "float64[] ids_confidence            # confidence of the possible ids in [0, 1]\n"
  "geometry_msgs/Point[] object_points # Array of object points in the object coordinate space.\n"
  "geometry_msgs/Point[] image_points  # Array of corresponding image points. Point.z is not used.";

static char msg_encoding[] = "msg";

// Define all individual source functions

const rosidl_runtime_c__type_description__TypeSource *
marker_msgs__msg__Fiducial__get_individual_type_description_source(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static const rosidl_runtime_c__type_description__TypeSource source = {
    {marker_msgs__msg__Fiducial__TYPE_NAME, 24, 24},
    {msg_encoding, 3, 3},
    {toplevel_type_raw_source, 438, 438},
  };
  return &source;
}

const rosidl_runtime_c__type_description__TypeSource__Sequence *
marker_msgs__msg__Fiducial__get_type_description_sources(
  const rosidl_message_type_support_t * type_support)
{
  (void)type_support;
  static rosidl_runtime_c__type_description__TypeSource sources[2];
  static const rosidl_runtime_c__type_description__TypeSource__Sequence source_sequence = {sources, 2, 2};
  static bool constructed = false;
  if (!constructed) {
    sources[0] = *marker_msgs__msg__Fiducial__get_individual_type_description_source(NULL),
    sources[1] = *geometry_msgs__msg__Point__get_individual_type_description_source(NULL);
    constructed = true;
  }
  return &source_sequence;
}
